package org.apache.bcel.generic;

import org.apache.bcel.Const;
import org.apache.bcel.classfile.ConstantPool;

public abstract class FieldInstruction extends FieldOrMethod
{
    FieldInstruction() {
    }
    
    protected FieldInstruction(final short opcode, final int index) {
        super(opcode, index);
    }
    
    public String getFieldName(final ConstantPoolGen cpg) {
        return this.getName(cpg);
    }
    
    protected int getFieldSize(final ConstantPoolGen cpg) {
        return Type.size(Type.getTypeSize(this.getSignature(cpg)));
    }
    
    public Type getFieldType(final ConstantPoolGen cpg) {
        return Type.getType(this.getSignature(cpg));
    }
    
    @Override
    public Type getType(final ConstantPoolGen cpg) {
        return this.getFieldType(cpg);
    }
    
    @Override
    public String toString(final ConstantPool cp) {
        return Const.getOpcodeName(super.getOpcode()) + " " + cp.constantToString(super.getIndex(), (byte)9);
    }
}
